function guibuilder(fn)
// GUI Builder Version 3.0. 
// Main Function for guibuilder
// Created on 19-Dec-2010 by Tan Chin Luh
// Modified on 10-Mar-2011 by Tan Chin Luh 
// Bug Fix : Style Properties Not Inserted into gencode
// New Features : Launch generated code 
// Modified on 12-July-2011 by Tan Chin Luh (2.1-3)
// Modified on 17-July-2011 by Tan Chin Luh (2.1-3)
// Modified on 12-November-2011 by D.Violeau (2.2)
// Modified on 17-November-2011 by Tan Chin Luh (2.2)
// Bug Fix : Space in the x_dialog default string
// Modified on 15-Dec-2011 by D.Violeau (2.3)
// New Features : Ask confirmation before create a new GUI or open an existing one
// New Features : Posibility to move by 4 buttons a group of buttons 
// Modified on 17-April-2014 by Tan Chin Luh (3.0) to work with Scilab 5.5

funcprot(0);

//************************
//Definition of variables
//************************
//global 
selnum =[];
preh=[];
handles.f1 = 1;    //main figure containing the guihelper
handles.f2 = 1;    //figure containing the user's uicontrols
handles.selected_items = 1;
handles.mylist = 1;    //list of tags for the user's uicontrols
handles.all_handles = []; //list of user's uicontrols
handles.alignments=1;    //handles used for alignments of uicontrols
handles.wires=[];    //rectangles for each user's uicontrol
handles.read_functions="";    //body of the previous functions read
handles.previous_functions=[];    //name of the previous functions
//handles.menus = [];
//definition of the main figure
handles.f1=figure('position',[20 50 300 480]);
drawlater()
delmenu(handles.f1.figure_id, gettext("File"));
delmenu(handles.f1.figure_id, gettext("Tools"));
delmenu(handles.f1.figure_id, gettext("Edit"));
delmenu(handles.f1.figure_id, gettext("?"));
toolbar(handles.f1.figure_id,'off');    // Added on 4-Mar-2011

mn=uimenu(handles.f1,'label', 'New','callback', 'new_gui(handles)');
mo=uimenu(handles.f1,'label', 'Open','callback', 'open_existing_gui(handles)');
m=uimenu(handles.f1,'label', 'Generate');
// create an item on the menu bar
m1=uimenu(m,'label', 'Generate GUI Code','callback', 'gencode_callback');

//definition of the aspect of the figure containing user's uicontrols
handles.f2=figure('position',[400 50 640 480]);//'backgroundcolor',[1,1,1]);
handles.f2.children.margins = [0 0 0 0];
handles.f2.children.axes_visible = ["on","on","on"]; // Added 17 July 2011 for Grid
handles.f2.children.grid = [1 1]; // Added 17 July 2011 for Grid
handles.f2.Tag = "f"; 
handles.f2.children.data_bounds=[0 0;1 1]; // Added 17 April 2014 to be compatible with 5.5
delmenu(handles.f2.figure_id,gettext("File"));
delmenu(handles.f2.figure_id,gettext("Tools"));
//delmenu(handles.f2.figure_id,gettext("Edit"));
delmenu(handles.f2.figure_id,gettext("?"));
toolbar(handles.f2.figure_id,'off');// Added on 4-Mar-2011
drawnow()

//definition of the structure containing user's menus, not in use for the moment
global menus nb_menus
menus.label="Main Menu"
menus.tag="main_menu"
menus.submenus=[]
nb_menus=0;
handles.menus=menus

//********************
//Initialize UIControl
//********************

x = 30;
y = 380;
w = 120;
h = 30;
w_offset = 30;

drawlater()
uicontrol(handles.f1, 'units','pixels', 'style', 'frame','position',[x-10 y-375 w*1.2 h*15],'fontsize',12,'FontWeight','bold');
uicontrol(handles.f1, 'units','pixels', 'style', 'frame','position',[x+110 y-375 w*1.2 h*15],'fontsize',12,'FontWeight','bold');
uicontrol(handles.f1, 'units','pixels', 'style', 'text','string','GUIBUILDER 3.0','position',[x+30 y+60 w*1.5 h],'fontsize',16,'FontWeight','bold');
//uicontrol(handles.f1, 'units','pixels', 'style', 'text','string','Components','position',[x+110 y+40 w h],'fontsize',12,'FontWeight','bold');

uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathrm{Pushbutton}$','FontAngle','normal','position',[x y w h],'fontsize',14,'callback','draw_uicontrol1(handles)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathrm{Radiobutton}$','position',[x y-w_offset*1 w h],'fontsize',14,'callback','draw_uicontrol2(handles)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathrm{Checkbox}$','position',[x y-w_offset*2 w h],'fontsize',14,'callback','draw_uicontrol3(handles)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathrm{Edit}$','position',[x y-w_offset*3 w h],'fontsize',14,'callback','draw_uicontrol4(handles)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathrm{Text}$','position',[x y-w_offset*4 w h],'fontsize',14,'callback','draw_uicontrol5(handles)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathrm{Slider}$','position',[x y-w_offset*5 w h],'fontsize',14,'callback','draw_uicontrol6(handles)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathrm{Frame}$','position',[x y-w_offset*6 w h],'fontsize',14,'callback','draw_uicontrol7(handles)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathrm{Listbox}$','position',[x y-w_offset*7 w h],'fontsize',14,'callback','draw_uicontrol8(handles)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathrm{Popupmenu}$','position',[x y-w_offset*8 w h],'fontsize',14,'callback','draw_uicontrol9(handles)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathrm{Axes}$','position',[x y-w_offset*9 w h],'fontsize',14,'callback','draw_uicontrol10(handles)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathrm{Spinner}$','position',[x y-w_offset*10 w h],'fontsize',14,'callback','draw_uicontrol11(handles)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathrm{Table}$','position',[x y-w_offset*11 w h],'fontsize',14,'callback','draw_uicontrol12(handles)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathrm{Image}$','position',[x y-w_offset*12 w h],'fontsize',14,'callback','draw_uicontrol13(handles)');
//uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathrm{Menu}$','position',[x y-w_offset*10 w h],'fontsize',16,'callback','menu_editor(handles)');

handles.mylist = uicontrol(handles.f1, 'units','pixels', 'style', 'listbox','string','','position',[x+1.05*w y-120 w h+140],'fontsize',10,'BackgroundColor',[1 1 1],'callback','select_highlight(handles)','max',2);
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathbf{Left}$','position',[x+1.05*w y-140-w_offset w/2 h/1.5],'fontsize',10,'callback',' Move_callback(selected_item,''left'')');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathbf{Right}$','position',[x+1.05*w+(w-w/2) y-140-w_offset w/2 h/1.5],'fontsize',10,'callback',' Move_callback(selected_item,''right'')');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathbf{Up}$','position',[x+1.05*w+w/4 y-140-w_offset+h/1.5 w/2 h/1.5],'fontsize',10,'callback',' Move_callback(selected_item,''up'')');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathbf{Down}$','position',[x+1.05*w+w/4 y-160-w_offset w/2 h/1.5],'fontsize',10,'callback',' Move_callback(selected_item,''down'')');

uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathbf{Move}$','position',[x+1.05*w y-160-w_offset*2 w h],'fontsize',10,'callback',' edit_callback(selected_item)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathbf{W-}$','position',[x+1.05*w y-160-w_offset*3 w/2 h],'fontsize',10,'callback','resizeW_callback(-1)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathbf{W+}$','position',[x+1.05*w+w/2 y-160-w_offset*3 w/2 h],'fontsize',10,'callback','resizeW_callback(1)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathbf{H-}$','position',[x+1.05*w y-160-w_offset*4 w/2 h],'fontsize',10,'callback','resizeH_callback(-1)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathbf{H+}$','position',[x+1.05*w+w/2 y-160-w_offset*4 w/2 h],'fontsize',10,'callback','resizeH_callback(1)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathbf{Delete}$','position',[x+1.05*w y-160-w_offset*5 w h],'fontsize',10,'callback','del_callback(handles)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathbf{Object Properties}$','position',[x+1.05*w y-160-w_offset*6 w h],'fontsize',10,'callback','obj_props(handles)');
uicontrol(handles.f1, 'units','pixels', 'style', 'pushbutton','string','$\mathbf{Alignements}$','position',[x+1.05*w y-160-w_offset*7 w h],'fontsize',10,'callback','guialignements(handles)');

//xrect([0 0 0 0]); handles.myrect = gce();
drawnow()

// To Import Existing GUI previously created by guibuilder 2.2
if argn(2) 
    openfile(handles,fn)
end
//h_control = resume(h_control);
//handles = resume(handles);
[handles,selnum,preh]= resume(handles,selnum,preh);
endfunction

//****************************
//UIControl Creation Functions
//****************************

// 1. PushButton
function draw_uicontrol1(handles)

    props = x_mdialog(['UIControl Properties'],['Tag';'String'],['';'']);    

    if props == []
        return
    end  

    if props(1) == ''
        props(1) = strcat(['obj',string(length(handles.all_handles)+1)]);
    end
    
    if props(2) == ''
        props(2) = strcat(['UnName',string(length(handles.all_handles)+1)]);
    end
    
    [rec,rec_axes] = draw_common();
    
    handles.current_handle = uicontrol(handles.f2, 'units','normalized', 'style', 'pushbutton','tag',props(1),'string',props(2),'position',rec,'fontsize',12,'callback','auto');
    handles.current_handle.userdata(2) = props(1);
    
    // Added on 12-Nov-2011 by D.Violeau : create a wire for this uicontrol
    scf(handles.f2); xrect([0 0 0 0]); myrect = gce();
    handles.wires=[handles.wires myrect]

    Update_handle(handles);
    handles = resume(handles);

endfunction

// 2. RadioButton
function draw_uicontrol2(handles)

    props = x_mdialog(['UIControl Properties'],['Tag';'String'],['';'']);    
    if props == []
        return
    end

    if props(1) == ''
        props(1) = strcat(['obj',string(length(handles.all_handles)+1)]);
    end

    if props(2) == ''
        props(2) = strcat(['UnName',string(length(handles.all_handles)+1)]);
    end

    [rec,rec_axes] = draw_common();
    
    handles.current_handle = uicontrol(handles.f2, 'units','normalized', 'style', 'radiobutton','tag',props(1),'string',props(2),'position',rec,'fontsize',12,'callback','auto');
    handles.current_handle.userdata(2) = props(1);

    // Added on 12-Nov-2011 by D.Violeau : create a wire for this uicontrol
    scf(handles.f2); xrect([0 0 0 0]); myrect = gce();
    handles.wires=[handles.wires myrect]

    Update_handle(handles);
    handles = resume(handles);

endfunction

// 3. CheckBox
function draw_uicontrol3(handles)
    
    props = x_mdialog(['UIControl Properties'],['Tag';'String'],['';'']);    
    if props == []
        return
    end  
    
    if props(1) == ''
        props(1) = strcat(['obj',string(length(handles.all_handles)+1)]);
    end

    if props(2) == ''
        props(2) = strcat(['UnName',string(length(handles.all_handles)+1)]);
    end

    [rec,rec_axes] = draw_common();
    
    handles.current_handle = uicontrol(handles.f2, 'units','normalized', 'style', 'checkbox','tag',props(1),'string',props(2),'position',rec,'fontsize',12,'callback','auto');
    handles.current_handle.userdata(2) = props(1);

    // Added on 12-Nov-2011 by D.Violeau : create a wire for this uicontrol
    scf(handles.f2); xrect([0 0 0 0]); myrect = gce();
    handles.wires=[handles.wires myrect]

    Update_handle(handles);
    handles = resume(handles);

endfunction

// 4. Edit Box 
function draw_uicontrol4(handles)
    
    props = x_mdialog(['UIControl Properties'],['Tag';'String'],['';'']);
    if props == []
        return
    end  

    if props(1) == ''
        props(1) = strcat(['obj',string(length(handles.all_handles)+1)]);
    end

    if props(2) == ''
        props(2) = strcat(['UnName',string(length(handles.all_handles)+1)]);
    end

    [rec,rec_axes] = draw_common();
    
    handles.current_handle = uicontrol(handles.f2, 'units','normalized', 'style', 'edit','tag',props(1),'string',props(2),'position',rec,'fontsize',12);
    handles.current_handle.userdata(2) = props(1);

    // Added on 12-Nov-2011 by D.Violeau : create a wire for this uicontrol
    scf(handles.f2); xrect([0 0 0 0]); myrect = gce();
    handles.wires=[handles.wires myrect]

    Update_handle(handles);
    handles = resume(handles);

endfunction

// 5. Text
function draw_uicontrol5(handles)
    
    props = x_mdialog(['UIControl Properties'],['Tag';'String'],['';'']);
    if props == []
        return
    end  

    if props(1) == ''
        props(1) = strcat(['obj',string(length(handles.all_handles)+1)]);
    end

    if props(2) == ''
        props(2) = strcat(['UnName',string(length(handles.all_handles)+1)]);
    end

    [rec,rec_axes] = draw_common();
    
    handles.current_handle = uicontrol(handles.f2, 'units','normalized', 'style', 'text','tag',props(1),'string',props(2),'position',rec,'fontsize',12);
    handles.current_handle.userdata(2) = props(1);

    // Added on 12-Nov-2011 by D.Violeau : create a wire for this uicontrol
    scf(handles.f2); xrect([0 0 0 0]); myrect = gce();
    handles.wires=[handles.wires myrect]

    Update_handle(handles);
    handles = resume(handles);

endfunction

// 6. Slider
function draw_uicontrol6(handles)

    props = x_mdialog(['UIControl Properties'],['Tag';'String'],['';'']);
    if props == []
        return
    end  

    if props(1) == ''
        props(1) = strcat(['obj',string(length(handles.all_handles)+1)]);
    end

    if props(2) == ''
        props(2) = strcat(['UnName',string(length(handles.all_handles)+1)]);
    end

    [rec,rec_axes] = draw_common();
    handles.current_handle = uicontrol(handles.f2, 'units','normalized', 'style', 'slider','tag',props(1),'string',props(2),'position',rec,'fontsize',12,'callback','auto','enable','off');
    handles.current_handle.userdata(2) = props(1);

    // Added on 12-Nov-2011 by D.Violeau : create a wire for this uicontrol
    scf(handles.f2); xrect([0 0 0 0]); myrect = gce();
    handles.wires=[handles.wires myrect]

    Update_handle(handles);
    handles = resume(handles);

endfunction

// 7. Frame
function draw_uicontrol7(handles)

    props = x_mdialog(['UIControl Properties'],['Tag';'String'],['';'']);
    if props == []
        return
    end  

    if props(1) == ''
        props(1) = strcat(['obj',string(length(handles.all_handles)+1)]);
    end

    if props(2) == ''
        props(2) = strcat(['UnName',string(length(handles.all_handles)+1)]);
    end

    [rec,rec_axes] = draw_common();
    handles.current_handle = uicontrol(handles.f2, 'units','normalized', 'style', 'frame','tag',props(1),'string',props(2),'position',rec,'fontsize',12);
    handles.current_handle.userdata(2) = props(1);

    // Added on 12-Nov-2011 by D.Violeau : create a wire for this uicontrol
    scf(handles.f2); xrect([0 0 0 0]); myrect = gce();
    handles.wires=[handles.wires myrect]

    Update_handle(handles);
    handles = resume(handles);

endfunction

// 8. ListBox
function draw_uicontrol8(handles)

    props = x_mdialog(['UIControl Properties'],['Tag';'String'],['';'']);
    if props == []
        return
    end  

    if props(1) == ''
        props(1) = strcat(['obj',string(length(handles.all_handles)+1)]);
    end

    if props(2) == ''
        props(2) = strcat(['UnName',string(length(handles.all_handles)+1)]);
    end

    [rec,rec_axes] = draw_common();
    handles.current_handle = uicontrol(handles.f2, 'units','normalized', 'style', 'listbox','tag',props(1),'string',props(2),'position',rec,'fontsize',12,'callback','auto');
    handles.current_handle.userdata(2) = props(1);

    // Added on 12-Nov-2011 by D.Violeau : create a wire for this uicontrol
    scf(handles.f2); xrect([0 0 0 0]); myrect = gce();
    handles.wires=[handles.wires myrect]

    Update_handle(handles);
    handles = resume(handles);

endfunction

// 9. Popup Menu
function draw_uicontrol9(handles)

    props = x_mdialog(['UIControl Properties'],['Tag';'String'],['';'']);
    if props == []
        return
    end  

    if props(1) == ''
        props(1) = strcat(['obj',string(length(handles.all_handles)+1)]);

    end

    if props(2) == ''
        props(2) = strcat(['UnName',string(length(handles.all_handles)+1)]);
    end

    [rec,rec_axes] = draw_common();
    handles.current_handle =  uicontrol(handles.f2, 'units','normalized', 'style', 'popupmenu','tag',props(1),'string',props(2),'position',rec,'fontsize',12,'callback','auto');
    handles.current_handle.userdata(2) = props(1);

    // Added on 12-Nov-2011 by D.Violeau : create a wire for this uicontrol
    scf(handles.f2); xrect([0 0 0 0]); myrect = gce();
    handles.wires=[handles.wires myrect]

    Update_handle(handles);
    handles = resume(handles);

endfunction



// 10. Axes
function draw_uicontrol10(handles)

    props = x_mdialog(['UIControl Properties'],['Tag';'String'],['';'']);
    if props == []
        return
    end  

    if props(1) == ''
        props(1) = strcat(['obj',string(length(handles.all_handles)+1)]);
    end

    if props(2) == ''
        props(2) = strcat(['UnName',string(length(handles.all_handles)+1)]);
    end


    [rec,rec_axes] = draw_common();
    xrect(rec_axes);
    handles.current_handle = gce();
    handles.current_handle.userdata(1) = props(1);
    handles.current_handle.userdata(2) = props(1);
    
    // Added on 12-Nov-2011 by D.Violeau : create a wire for this uicontrol
    scf(handles.f2); xrect([0 0 0 0]); myrect = gce();
    handles.wires=[handles.wires, myrect]

    Update_handle(handles);
    handles = resume(handles);

endfunction


// 11. Spinner
function draw_uicontrol11(handles)

    props = x_mdialog(['UIControl Properties'],['Tag';'String'],['';'']);
    if props == []
        return
    end  

    if props(1) == ''
        props(1) = strcat(['obj',string(length(handles.all_handles)+1)]);
    end

    if props(2) == ''
        props(2) = strcat(['UnName',string(length(handles.all_handles)+1)]);
    end

    [rec,rec_axes] = draw_common();
    handles.current_handle =  uicontrol(handles.f2, 'units','normalized', 'style', 'spinner','tag',props(1),'string',props(2),'position',rec,'fontsize',12,'callback','auto');
    handles.current_handle.userdata(2) = props(1);

    // Added on 12-Nov-2011 by D.Violeau : create a wire for this uicontrol
    scf(handles.f2); xrect([0 0 0 0]); myrect = gce();
    handles.wires=[handles.wires myrect]

    Update_handle(handles);
    handles = resume(handles);

endfunction

// 12. Table
function draw_uicontrol12(handles)

    props = x_mdialog(['UIControl Properties'],['Tag';'String'],['';'']);
    if props == []
        return
    end  

    if props(1) == ''
        props(1) = strcat(['obj',string(length(handles.all_handles)+1)]);
    end

    if props(2) == ''
        props(2) = strcat(['UnName',string(length(handles.all_handles)+1)]);
    end

    [rec,rec_axes] = draw_common();
    handles.current_handle =  uicontrol(handles.f2, 'units','normalized', 'style', 'table','tag',props(1),'string',props(2),'position',rec,'fontsize',12,'callback','auto');
    handles.current_handle.userdata(2) = props(1);

    // Added on 12-Nov-2011 by D.Violeau : create a wire for this uicontrol
    scf(handles.f2); xrect([0 0 0 0]); myrect = gce();
    handles.wires=[handles.wires myrect]

    Update_handle(handles);
    handles = resume(handles);

endfunction

// 13. Image
function draw_uicontrol13(handles)

    props = x_mdialog(['UIControl Properties'],['Tag';'String'],['';'']);
    if props == []
        return
    end  

    if props(1) == ''
        props(1) = strcat(['obj',string(length(handles.all_handles)+1)]);
    end

    if props(2) == ''
        props(2) = strcat(['UnName',string(length(handles.all_handles)+1)]);
    end

    [rec,rec_axes] = draw_common();
    handles.current_handle =  uicontrol(handles.f2, 'units','normalized', 'style', 'image','tag',props(1),'string',props(2),'position',rec,'fontsize',12,'callback','auto');
    handles.current_handle.userdata(2) = props(1);

    // Added on 12-Nov-2011 by D.Violeau : create a wire for this uicontrol
    scf(handles.f2); xrect([0 0 0 0]); myrect = gce();
    handles.wires=[handles.wires myrect]

    Update_handle(handles);
    handles = resume(handles);

endfunction

// 11. Menus (not in use for the moment)
function draw_uicontrol1x(handles)

    props = x_mdialog(['UImenu Properties'],['Tag';'Label';'Parent Tag'],['';'';'main_figure']);
    if props == []
        return
    end  

    if props(1) == ''
        props(1) = strcat(['obj',string(length(handles.all_handles)+1)]);
    end

    if props(2) == ''
        props(2) = strcat(['UnName',string(length(handles.all_handles)+1)]);
    end
    
    select_handle_menu=handles.f2
    for cnt=1:length(handles.all_handles)
        if(handles.all_handles(cnt).type=="uimenu") then
            if(props(3)==handles.all_handles(cnt).Tag) then
                select_handle_menu=handles.all_handles(cnt)
            end
        end
    end
    
    handles.current_handle = uimenu("Parent", select_handle_menu, "Label", props(2),"Tag",props(1));
    handles.current_handle.userdata(2) = props(1);

    Update_handle(handles);
    handles = resume(handles);

endfunction



//****************************
// Start of Common Functions
//****************************

//-----------------------------
// Drawing Functions
//-----------------------------
function [rec,rec_axes] = draw_common()
  scf(handles.f2);  
  [b,xc,yc]=xclick(); //get a point
  xrect(xc,yc,0,0) //draw a rectangle entity
  r=gce();// the handle of the rectangle
  rep=[xc,yc,-1];first=%f;
  
  while rep(3)==-1 do // mouse just moving ...
    rep=xgetmouse();
    xc1=rep(1);yc1=rep(2);
    ox=min(xc,xc1);
    oy=max(yc,yc1);
    w=abs(xc-xc1);h=abs(yc-yc1);
    r.data=[ox,oy,w,h]; //change the retangle origin, width an height
    first=%f;
  end
  
  rec_axes = r.data;
  rec(1) = (min(xc,xc1)) ;
  rec(2) = (min(yc,yc1)) ;
  rec(3) = (max(xc,xc1) - min(xc,xc1)); 
  rec(4) = (max(yc,yc1) - min(yc,yc1));
  
  rec = rec';
  delete(r);
endfunction

//--------------------------------------
// Update the List of Components Handles
//--------------------------------------
function Update_handle(handles)  
  handles.all_handles = [handles.all_handles handles.current_handle];
    
  for cnt = 1:length(handles.all_handles)
    templist(cnt) = handles.all_handles(cnt).user_data(2);
  end

// Removed on 17-Nov-2011 by Tan C.L. : To enable the object created for Axes too, pending for review.
//  if(handles.current_handle.type=="uicontrol") then
//      set(handles.mylist,'string',string(templist));
//  elseif(handles.current_handle.type=="uimenu") then
     set(handles.mylist,'string',string(templist));
//  end

  handles = resume(handles);
endfunction 

//-----------------------------
// Delete Selected Components
//-----------------------------
function del_callback(handles)

   delete(handles.all_handles(selected_item));  
   handles.all_handles = handles.all_handles(is_handle_valid(handles.all_handles));
   delete(handles.wires(selected_item)) // Added on 12.Nov.2011 by D.Violeau to delete uicontrol wire
   handles.wires = handles.wires(is_handle_valid(handles.wires))
   if isempty(handles.all_handles)  // Added on 17 July to delete last remaining item
       templist = '';
       set(handles.mylist,'string',templist);
       handles.myrect.data = [0 0 0 0];
       handles.all_handles=[]
   else
       for cnt = 1:length(handles.all_handles)
           templist(cnt) = handles.all_handles(cnt).user_data(2);
       end

       set(handles.mylist,'string',string(templist));
       update_unname(handles)
   end
   handles = resume(handles);
   
endfunction 

//--------------------------------
// Assign name to un-named objects
//--------------------------------
// ToDo: Auto increment without reseting previous deleted items
function update_unname(handles)

  templist = get(handles.mylist,'string');
  tempcnt = size(templist,2);
  
  for cnt = 1:tempcnt
    if isempty(handles.all_handles(cnt).Userdata(1))
      if strindex(handles.all_handles(cnt).tag,'obj')
         handles.all_handles(cnt).tag = strcat(['obj',string(cnt)]);
      end
      if strindex(strcat(handles.all_handles(cnt).String),'UnName')
         handles.all_handles(cnt).String = strcat(['UnName',string(cnt)]);
      end
      if strindex(handles.all_handles(cnt).user_data(2),'obj')
         handles.all_handles(cnt).user_data(2) = strcat(['obj',string(cnt)]);
      end       
    else
      if strindex(handles.all_handles(cnt).user_data(1),'obj')
         handles.all_handles(cnt).user_data(1) = strcat(['obj',string(cnt)]);
      end
      if strindex(handles.all_handles(cnt).user_data(2),'obj')
         handles.all_handles(cnt).user_data(2) = strcat(['obj',string(cnt)]);
      end       
    end
         
    clear templist tempcnt;
  end
  
  for cnt = 1:length(handles.all_handles)
    templist(cnt) = handles.all_handles(cnt).user_data(2);
  end
  set(handles.mylist,'string',templist);
  handles = resume(handles);
     
endfunction

//-----------------------------
// Move the Selected Items
//-----------------------------
function edit_callback(selected_item)
  if(length(selected_item)>1) then
      messagebox("Select only one handle", "Move error message", "Error","modal");
  else      
      if isempty(handles.all_handles(selected_item).Userdata(1))
        data = handles.all_handles(selected_item).Position + [0 handles.all_handles(selected_item).Position(4) 0 0];
        r = dragrect(data);
        set(handles.all_handles(selected_item),'Position',r'-[0 handles.all_handles(selected_item).Position(4) 0 0]);    
      else
        data = handles.all_handles(selected_item).data;
        r = dragrect(data);
        set(handles.all_handles(selected_item),'data',r');
      end
      //handles.f1.children($).visible = 'off';
      select_highlight(handles);
      handles = resume(handles);
  end
endfunction

//-----------------------------
// Move the Selected Items to the left
//-----------------------------
function Move_callback(selected_item,direction)
    sz=1;
    move_vector=[0 0 0 0]
    if direction=="left" then
       move_vector=[-sz/100 0 0 0];
    elseif direction=="right" then
       move_vector=[sz/100 0 0 0];
    elseif direction=="up" then
       move_vector=[0 sz/100 0 0];
    elseif direction=="down" then
       move_vector=[0 -sz/100 0 0];       
    end
    for cnt=1:size(selected_item,2)
        if isempty(handles.all_handles(selected_item(cnt)).Userdata(1))
          newszW = handles.all_handles(selected_item(cnt)).Position + move_vector;
          set(handles.all_handles(selected_item(cnt)),'Position',newszW);
        else
          newszW = handles.all_handles(selected_item(cnt)).data + move_vector;
          set(handles.all_handles(selected_item(cnt)),'data',newszW);
        end   
    end

    select_highlight(handles);
    handles = resume(handles);
endfunction


//-----------------------------
// Highlight the Selection
//-----------------------------
//Changed on 12.11.2011 by D.Violeau : possibility to highlight more than one handle
function select_highlight(handles)
  selected_items = get(handles.mylist,'value');
  //disp(selected_items)

  for cnt=1:length(handles.wires)
      set(handles.wires(cnt),'visible',"off");
  end

  for cnt=selected_items
     if isempty(handles.all_handles(cnt).Userdata(1))
       set(handles.wires(cnt),'data',handles.all_handles(cnt).Position + [0 handles.all_handles(cnt).Position(4) 0 0]);// ;
       set(handles.wires(cnt),'thickness',10);//;
       set(handles.wires(cnt),'foreground',5);//;
       set(handles.wires(cnt),'mark_style',3);
       set(handles.wires(cnt),'mark_foreground',5);
       set(handles.wires(cnt),'visible',"on");
     else
       set(handles.wires(cnt),'data',handles.all_handles(cnt).data);// ;
       set(handles.wires(cnt),'thickness',10);//;
       set(handles.wires(cnt),'foreground',5);//;
       set(handles.wires(cnt),'mark_style',3);
       set(handles.wires(cnt),'mark_foreground',5);
       set(handles.wires(cnt),'visible',"on");
     end
 end
 selected_item = resume(selected_items)
 handles=resume(handles)
endfunction

//-----------------------------
// Resize Width Function
//-----------------------------
function resizeW_callback(sz)
  if(length(selected_item)>1) then
      messagebox("Select only one handle", "resizeW error message", "Error","modal");
  else      
    if isempty(handles.all_handles(selected_item).Userdata(1))
      newszW = handles.all_handles(selected_item).Position + [0 0 sz./100 0];
      set(handles.all_handles(selected_item),'Position',newszW);
    else
      newszW = handles.all_handles(selected_item).data + [0 0 sz./100 0];
      set(handles.all_handles(selected_item),'data',newszW);
    end
  end
  select_highlight(handles);

endfunction

//-----------------------------
// Resize Height Function
//-----------------------------
function resizeH_callback(sz)
    if(length(selected_item)>1) then
        messagebox("Select only one handle", "resizeH error message", "Error","modal");
    else 
        if isempty(handles.all_handles(selected_item).Userdata(1))  
          newszH = handles.all_handles(selected_item).Position + [0 0 0 sz./100];
          set(handles.all_handles(selected_item),'Position',newszH);
        else
          newszH = handles.all_handles(selected_item).data + [0 0 0 sz./100];
          set(handles.all_handles(selected_item),'data',newszH);
        end
    end
    select_highlight(handles);
endfunction

//---------------------------------------------
// Open properties dialog for the selected uicontrol
//---------------------------------------------
function obj_props(handles)
    if(length(selected_item)>1) then
        messagebox("Select only one handle", "ObjectProperties error message", "Error","modal");
    else 
        selected_handle = handles.all_handles(selected_item);
        guipropsedit(selected_handle);
        selected_handle.userdata(2) = get(selected_handle,'tag');
        for cnt = 1:length(handles.all_handles)
            templist(cnt) = handles.all_handles(cnt).user_data(2);
        end
        set(handles.mylist,'string',templist);
        handles = resume(handles);
    end
    
endfunction

//-----------------------------
// Calling function to generate the GUI
//-----------------------------
function gencode_callback
  fn = uiputfile(["*.sce";]);
  err = guigencode(fn,handles.all_handles, handles);
  if err == 0 then
      messagebox("GUI Created Sucessfully!", "GUI Created", "info","modal");
  else
      messagebox("Unexpected Error. GUI Not Created!", "GUI Not Created", "Error","modal");
  end
  // Added on 06.1112011 by D.Violeau to load a file with or without extension
  ind=strindex(fn,'.sce')
  fn2=fn
  if (ind==[]) then
    fn2=strcat([fn,'.sce'])
  end
  
  edit(fn2);
endfunction 

//--------------------------------------
// Calling function to open an existing GUI
//--------------------------------------
function openfile(handles,fn)
    handles.previous_functions=[]
    handles.read_functions=""
    a = guigetfile(fn, handles);
    [r,c] = size(a);
    for cnt = 1:r
      temp_tag = strsplit(a(cnt));
        if strcat(temp_tag(1:9)') == 'uicontrol'
            handles.current_handle = eval(a(cnt));
            handles.current_handle.userdata(2) = get(handles.current_handle,'tag');
            scf(handles.f2); xrect([0 0 0 0]); myrect = gce();
            handles.wires=[handles.wires, myrect]
            Update_handle(handles);   
        elseif strcat(temp_tag(1:6)') == 'figure'
            handles.f2=eval(a(cnt));
            handles.f2.children.margins = [0 0 0 0];
            handles.f2.children.data_bounds=[0 0;1 1]; // Added 17 April 2014 to be compatible with 5.5             
            handles.f2.children.axes_visible = ["on","on","on"]; 
            handles.f2.children.grid = [1 1]; 
            handles.f2.Tag = "f"; 
            delmenu(handles.f2.figure_id,gettext("File"));
            delmenu(handles.f2.figure_id,gettext("Tools"));
            delmenu(handles.f2.figure_id,gettext("?"));
            toolbar(handles.f2.figure_id,'off');
            handles.all_handles = [];
            handles.wires=[];
            set(handles.mylist,'string','');
            xrect([0 0 0 0]); handles.myrect = gce();
        else
            ind1 = strindex(a(cnt),'=[');
            temp_tag = strsplit(a(cnt));
            rec_axes = eval(strcat(temp_tag(ind1+1:$)'));
            rec_axes(2) = 1 - rec_axes(2);
            scf(handles.f2);
            xrect(rec_axes);
            handles.current_handle = gce();
            handles.current_handle.userdata(1) = (strcat(temp_tag(1:ind1-1)'));
            handles.current_handle.userdata(2) = (strcat(temp_tag(1:ind1-1)'));
            //Added by Tan C.L. on 17.11.2011
            xrect([0 0 0 0]); myrect = gce();
            handles.wires=[handles.wires, myrect]

            Update_handle(handles);
        end    
    end
    handles = resume(handles);
endfunction 

function open_existing_gui(handles)
    msg = gettext("Do you really want to open an existing GUI ? The current GUI will be lost.");
    answ = messagebox(msg, gettext("Open an existing GUI"), "question", [gettext("Yes") gettext("No")], "modal");
    if answ==1 then
        try
            delete(handles.f2);
        end
        fn = uigetfile(["*.sce";]);
        openfile(handles,fn)
    end
    
    handles=resume(handles)
endfunction

//--------------------------------------
// Calling function to create a new GUI
//--------------------------------------
function new_gui(handles)
    msg = gettext("Do you really want to create a new GUI ? The current GUI will be lost.");
    answ = messagebox(msg, gettext("New GUI"), "question", [gettext("Yes") gettext("No")], "modal");
    if answ==1 then
        try
            delete(handles.f2);
        end
        handles.f2=figure('position',[400 50 640 480],'backgroundcolor',[0.8,0.8,0.8]);//'backgroundcolor',[1,1,1] 
        handles.f2.children.margins = [0 0 0 0];
        handles.f2.children.data_bounds=[0 0;1 1]; // Added 17 April 2014 to be compatible with 5.5        
        handles.f2.children.axes_visible = ["on","on","on"]; 
        handles.f2.children.grid = [1 1]; 
        handles.f2.Tag = "f"; 
        delmenu(handles.f2.figure_id,gettext("File"));
        delmenu(handles.f2.figure_id,gettext("Tools"));
        delmenu(handles.f2.figure_id,gettext("?"));
        toolbar(handles.f2.figure_id,'off');
        handles.all_handles = [];
        set(handles.mylist,'string','');
        xrect([0 0 0 0]); handles.myrect = gce();
        handles.wires=[];
        handles.previous_functions=[]
        handles.read_functions=""
    end
    handles=resume(handles)
endfunction




function auto()
    
//  e = gcbo();
//  all_h = get(handles.mylist,'string');
//  sel_h = strcmp(all_h,e.tag);
//
//  selected_items = find(sel_h==0);
//  set(handles.mylist,'value',selected_items);  
//  
//  for cnt=1:length(handles.wires)
//      set(handles.wires(cnt),'visible',"off");
//  end
//
//  for cnt=selected_items
//     if isempty(handles.all_handles(cnt).Userdata(1))
//       set(handles.wires(cnt),'data',handles.all_handles(cnt).Position + [0 handles.all_handles(cnt).Position(4) 0 0]);// ;
//       set(handles.wires(cnt),'thickness',10);//;
//       set(handles.wires(cnt),'foreground',5);//;
//       set(handles.wires(cnt),'mark_style',3);
//       set(handles.wires(cnt),'mark_foreground',5);
//       set(handles.wires(cnt),'visible',"on");
//     else
//       set(handles.wires(cnt),'data',handles.all_handles(cnt).data);// ;
//       set(handles.wires(cnt),'thickness',10);//;
//       set(handles.wires(cnt),'foreground',5);//;
//       set(handles.wires(cnt),'mark_style',3);
//       set(handles.wires(cnt),'mark_foreground',5);
//       set(handles.wires(cnt),'visible',"on");
//     end
// end
// 
//disp(selnum) 
//
//  if e.tag == preh then
//      selnum = selnum + 1;
//  end
//
//
//  if selnum >= 1 then
////      act = messagebox("What do you want to do?", "Choose your action", "question", ["Edit Properties" "Move The UIControl"], "modal");
////      if act ==1 then
////          edit_callback(selected_items);
////      else
////          edit_callback(selected_items);
////      end 
//      selnum = 0;
//  end
//  
//  [ibutton,xcoord,yxcoord,iwin,cbmenu]=xclick();
//  disp(ibutton);
//
//preh = e.tag;
//
//[selnum,preh] = resume(selnum,preh);
//
  
endfunction
